function [fire, transition] = COMMON_PRE(transition)
% function [fire, trans] = COMMON_PRE(transition)

global global_info

if ismember(transition.name, {'tInitialize','tEvents', 'tDead'})
    % tInitialize, tEvents, tDead have their own specific pre-processors
    fire = 1;
    return
end

%%%%%%% here comes the specialists: tMarried, tChildBirth, tDead
switch transition.name 
    case 'tMarry'
        tokIDmarried = tokenAnyColor('pCommunity',1, {'married'});
        if tokIDmarried

            transition.selected_tokens = tokIDmarried;
            transition.override = 1;   
            fire = 1;
        else
            fire = 0;
        end
        
    case 'tMarry_update'
        Newly_married = global_info.MARRIED_COUPLE;
        if not(isempty(Newly_married.man))
            updateCommunity('Marry', Newly_married.woman, Newly_married.man);
            transition.new_color = Newly_married.man;
            global_info.MARRIED_COUPLE.man = '';
            fire = 1;
        else % MARRIED_COUPLE.man == ''
            transition.new_color = Newly_married.woman;
            fire = 1;
        end

    case 'tBirth'
        tokIDborn = tokenAnyColor('pCommunity',1, {'born'});
        if tokIDborn
            transition.selected_tokens = tokIDborn;
            transition.override = 1;   
            fire = 1;
        else
            fire = 0;
        end        

    case 'tBirth_update'
        new_birth = global_info.BIRTH;
        if not(isempty(new_birth.mum))
            global_info.BIRTH.mum = ''; % set for the second pass
            mum = new_birth.mum; 
            baby_name = new_birth.baby_name;
            baby_gender = new_birth.baby_gender;
            updateCommunity('Birth', mum, baby_name, baby_gender);
            transition.new_color = mum;
            fire = 1;
        else % new_birth.mum == ''
            baby_name = new_birth.baby_name;
            transition.new_color = baby_name;
            fire = 1;
        end        

    case 'tDivorce'   
        tokIDdivorced = tokenAnyColor('pCommunity',1, {'divorced'});
        if tokIDdivorced    
            transition.selected_tokens = tokIDdivorced;
            transition.override = 1;   
            fire = 1;
        else
            fire = 0;
        end

    case 'tDivorce_update'
        divorcees = global_info.DIVORCE;
        if not(isempty(divorcees.woman))
            woman = divorcees.woman;
            man = divorcees.man;
            updateCommunity('Divorce', woman, man);
            global_info.DIVORCE.woman = ''; % set for the second round
            transition.new_color = woman;
            fire = 1;
        else % divorcees.woman == ''
            man = divorcees.man;
            transition.new_color = man;
            fire = 1;
        end
     
    otherwise
        fire = 0;
end