% Sample code from the book: "Colored Petri Nets for 
% Modeling of Discrete Systems: A practical approach with GPenSIM"
% 
% Example-18: Indexed Coloring
% Reggie.Davidrajuh@uis.no (c) 12 April 2023  
% File: Main Simulation File (msf.m)


clear all; clc;

global global_info
global_info.STOP_AT = 300; 

% load the INITIAL "micro community"
COMMUNITY_AT_START();
initial_community_size = global_info.Community_Size;

global_info.EVENTS = {...
  20, 'Marry', 'Olivia', 'Robert',...
  30, 'Marry','Isabella','David', ...        
  40, 'Death', 'Michael',...
  50, 'Birth', 'Sophia', 'Rockson', 'Male', ...
  60, 'Divorce','Olivia', 'Robert',...                      
  70, 'Birth', 'Sophia', 'Maddy', 'Female',...
  80, 'Birth', 'Isabella', 'Tom', 'Male'}; 

global_info.events_index = 1;  % initialize events pointer                  

png = pnstruct('icolor_pdf');

%%%% initial dynamics %%%%
dyn.m0 = {'pInitialize', 2 * initial_community_size};
dyn.ft = {'allothers',1};
pni = initialdynamics(png, dyn);

sim = gpensim(pni);
prnCommunity();

prnfinalcolors(sim); 
